//Client.cc

#include "Client.h"
#include <stdlib.h>
#include <sys/ipc.h>   //file
#include <sys/msg.h>   //file
#include <unistd.h>    //file
#include <sys/types.h> //tube
#include <fcntl.h> //pid
#include <sys/stat.h>  //tube
#include <iostream.h> //entres sorties
#include <time.h>

Client::Client()
{
 create(true);
}

Client::Client(bool automatik)
{
 create(automatik);
}

void Client::create(bool automatik) //suite du constructeur
{
 automatique=automatik;
 msgperso.etiquette=getpid(); //pour lire l'tiquette au nom de l'instance de Client
 srand(int(time(NULL))); //initialise le gnrateur random
 affiche("Cr");
 //cration de la file avec le fichier "toto"
 key_t clefile=ftok("toto",'x');
 idfile=msgget(clefile,IPC_CREAT|0666);
 //affiche("file de messages "+int10ToStr(msgperso.etiquette)+" cre avec succs");
 //ouverture du tube nomm en criture sur le fichier "tata"
 tube=open("tata",O_WRONLY);
 if (tube<0) stop(); //erreur ouverture du tube
 else run();
}

Client::~Client()
{
 close(tube); //fermeture du tube nomm
 affiche("Dtruit");
}

void Client::run() //pour dmarrer l'activit du Client
{
 ok=true;
 ecouterFile();
 stop();
}

void Client::stop() //pour arrter l'activit du Client
{
 if (msgperso.etiquette==getpid()) //le code ne doit tre excut que par le pre (cf. fork())
 {
  ok=false;
  //sleep(1);
  delete this;
 }
}

void Client::suicide() //autodestruction du processus de l'instance Client
{
 affiche("Suicid");
}

void Client::consommer(int duree) //consomme une dure en secondes et fait un choix
{
 sleep(duree); //consomme

 switch(lireChoix(7)) //entre 1..7
 {
  case 1 : // nouveau candidat (1/7 chance)
  //case 2 :
  {
   transmettre(1);
   ecouterFile();
   break;
  }
  case 2 : //dsistement (1/7 chance)
  {
   transmettre(2);
   break;
  }
  case 3 : //cration fils et dsistement (2/7 chance)
  case 4 :
  {
   creerFils(2);
   //!! ne mettre aucun code car il serait appel par le pre et le fils
   break;
  }
  case 5 : //cration fils et candidat (3/7 chance)
  case 6 :
  case 7 :
  {
   creerFils(1);
   //!! ne mettre aucun code car il serait appel par le pre et le fils
   break;
  }
  default : transmettre(2); //en cas d'erreur dsistement
 }
}

void Client::creerFils(int param) //cre un processus fils Client et le prsente  GrandElecteur
{                                 //param est le choix (candidat ou dsistement) du processus pre
 pid_t monpid=fork(); //duplique le processus en cours
 switch (monpid)
 {
  case -1 : //erreur de fork()
  {
   suicide();
   break;
  }
  case 0 : //processus fils : nouveau Client
  {
   Client *monClient=new Client(automatique); //le run puis le delete sont appels dans le constructeur
   //!! le code ci-dessous est excut par tous les clients
   break;
  }
  default : //processus pre : reste Client
  {
   //affiche(" prsente son fils "+int10ToStr(monpid));
   transmettre(monpid); //prsente le fils  GrandElecteur
   transmettre(param); //puis envoit le choix (candidat ou dsistement)
   if (param==1) ecouterFile(); //si candidat, coute  nouveau
  }
 }
}

void Client::transmettre(int codeMessage) //transmet au GrandElecteur les choix par le tube nomm
{
 affiche(" envoie "+int10ToStr(codeMessage)+" dans le tube");
 write(tube,&codeMessage,sizeof(int)); //criture dans le tube
}

void Client::ecouterFile() //reoit les signaux du GrandElecteur et agit en consquence
{
 //affiche(" en attente de message dans la file");
 int reception=msgrcv(idfile,&msgperso,sizeof(msgperso.contenu),msgperso.etiquette,0);
 affiche(" a reu un quantum de temps de "+int10ToStr(short(msgperso.contenu)));
 if ((msgperso.contenu>0) && ok) consommer(msgperso.contenu);
 else suicide(); //cas o le programme principal se termine => fin de tous les processus
}

void Client::affiche(string texte)
{
 cout<<"Client "<<msgperso.etiquette<<" : "<<texte<<endl;
}

char Client::lireChoix(short maxi) //permet  l'utilisateur d'entrer le choix que doit faire le Client
{
 if (automatique) return (1+(int)((float)(maxi)*rand()/(RAND_MAX+1.0)));
 else
 {
  affiche("Entrez choix entre 1 et "+int10ToStr(maxi));
  short lecture;
  cin>>lecture;
  if ((1<=lecture)&&(lecture<=maxi)) return lecture;
  else lireChoix(maxi);
 }
}
