//GrandElecteur.cc

#include "GrandElecteur.h"
#include <stdlib.h>
#include <sys/ipc.h>   //file
#include <sys/msg.h>   //file
#include <unistd.h>    //file
#include <sys/types.h> //tube
#include <sys/stat.h>  //tube
#include <iostream.h> //entres sorties

GrandElecteur::GrandElecteur()
{
 create(1,30);
}

GrandElecteur::GrandElecteur(short politik)
{
 create(politik,30);
}

GrandElecteur::GrandElecteur(short politik, short temps)
{
 create(politik,temps);
}

void GrandElecteur::create(short politik,short temps) //sutite du constructeur
{
 affiche("cr comme processus "+int10ToStr(getpid()));
 dernierElu=0;
 politique=politik;
 heureDepart=time(NULL);
 tempsMax=temps;
 srand(int(time(NULL))); //initialise le gnrateur random
 size=0;
 capacity=5;
 table=new int[capacity];
 //cration de la file avec le fichier "toto"
 key_t clefile=ftok("toto",'x');
 idfile=msgget(clefile,IPC_CREAT|0666);
 affiche("File de messages cre avec succs");
 //cration du tube nomm sur le fichier "tata" et ouverture en lecture
 if (mkfifo("tata",0666)!=-1)
 {
  tube=open("tata",O_RDONLY);
  if (tube<0) exit(1);
  else affiche("Tube nomm cr avec succs");
  ok=true;
 }
 else exit(1);
}

GrandElecteur::~GrandElecteur()
{
 affiche("dtruit");
 if (size>0) stop(); //au cas o le destructeur serait appel avant stop()
 delete table;
 int fermer=msgctl(idfile,IPC_RMID,NULL); //destruction de la file
 close(tube); //fermeture du tube nomm
 unlink("tata"); //destruction du tube
}

void GrandElecteur::run(pid_t premierClient) //pour dmarrer l'activit de GrandElecteur
{
 addClient(int(premierClient));
 election(); //passe la main au nouveau processus
 while (ok) ecouterTube();
 affiche("Fin de GrandElecteur");
}

void GrandElecteur::stop() //pour arrter l'activit de GrandElecteur

{
 sleep(2); //laisse du temps aux processus pour passer en coute
 ok=false;
 for (int cpt=0; cpt<size; cpt++) transmettre(table[cpt],0); //transmet un ordre de suicide  tous les processus
 size=0;
 sleep(4); //laisse du temps aux processus pour lire dans leur file
}

int GrandElecteur::selection() //retourne un n de processus au hasard
{
 switch(politique)
 {
  case 1 : //RANDOM
  {
   return table[(int)((float)(size)*rand()/(RAND_MAX+1.0))]; //entre 0 et size-1
   break;
  }
  case 2 : //TOURNIQUET
  {
   dernierElu=((dernierElu+1) % size); //entre 0 et size-1
   return table[dernierElu];
   break;
  }
  case 3 : //LILO
  {
   return table[size-1];
   break;
  }
  case 4 : //FIFO
  {
   return table[0];
   break;
  }
  default :
  {
   politique=1; //RANDOM
   return selection();
  }
 }
}

char GrandElecteur::randQuantum() //retourne un quantum de temps (secondes) au hasard entre 1 et 3
{
 return (1+(char)(3.0*rand()/(RAND_MAX+1.0))); //entre 1 et 3
}

int GrandElecteur::getClient(int numProc) //retourne l'index dans table du client de n de processus numProc
{
 bool trouve=false;
 int cpt=-1;
 while ((!trouve)&&(cpt<(size-1)))
 {
  cpt++;
  trouve=(table[cpt]==numProc);
 }
 return cpt; //si le client n'a pas t trouv, retourne size
}

void GrandElecteur::addClient(int numProc) //ajoute un n de processus  table
{
 if (size<capacity)
 {
  table[size]=numProc;
  affiche("ajoute le client "+int10ToStr(numProc)+"  l'indice "+int10ToStr(size));
  size++;
 }
 else //augmentation de table
 {
  affiche("Agrandit table");
  int *ancien=table;
  table=new int[capacity+5];
  for (int cpt=0; cpt<size; cpt++) table[cpt]=ancien[cpt];
  capacity+=5;
  delete ancien;
  addClient(numProc);
 }
}

void GrandElecteur::rmClient(int numProc) //supprime un n de processus de table
{
 if (size>(capacity-10))
 {
  int indice=getClient(numProc);
  affiche("supprime le client "+int10ToStr(numProc)+"  l'indice "+int10ToStr(indice));
  for (int cpt=indice; cpt<(size-1); cpt++) table[cpt]=table[cpt+1]; //dcallage
  size--;
  if (size<=0)
  {
   affiche("Plus de clients");
   stop();
  }
 }
 else //rduction de table
 {
  affiche("Rduit table");
  int *ancien=table;
  table=new int[size+4];
  for (int cpt=0; cpt<size; cpt++) table[cpt]=ancien[cpt];
  capacity=size+4;
  delete ancien;
  rmClient(numProc);
 }
}

void GrandElecteur::election() //appelle selection() puis transmet au processus concern son lection
{
 string liste="Liste des processus";
 for (int cpt=0; cpt<size; cpt++) liste+=", "+int10ToStr(table[cpt]);
 affiche(liste);
 transmettre(selection(),randQuantum());
}

void GrandElecteur::transmettre(int numProc, char quantumTemps) //transmet au client n numProc son lection et son quantum de temps
{
 msgperso.etiquette=numProc;
 msgperso.contenu=quantumTemps;
 numProcActif=numProc; //change le processus actif
 affiche("lit processus "+int10ToStr(numProcActif)+" avec un quantum de temps de "+int10ToStr(short(quantumTemps)));
 int envoie=msgsnd(idfile,&msgperso,sizeof(msgperso.contenu),0);
}

bool GrandElecteur::continuer() //retourne si le GrandElecteur doit continuer son travail (arrt au bout de tempsMax)
{
 return (ok&&((time(NULL)-heureDepart)<tempsMax));
}

void GrandElecteur::ecouterTube() //reoit les signaux du client actif et agit en consquence
{
 int code;
 //affiche("en attente de message du client "+int10ToStr(numProcActif)+" dans le tube");
 read(tube,&code,sizeof(int)); //lecture dans le tube
 //affiche("a reu dans le tube "+int10ToStr(code)+" de "+int10ToStr(numProcActif));

 if (code<1) //erreur de lecture dans le tube
 {
  affiche("Erreur tube");
  stop();
 }
 else if (code>2) addClient(code); //prsentation fils : code est le numro du processus fils
 else //nouvelle lection
 {
  if (code==2) { rmClient(numProcActif); numProcActif=-1;} //desistement
  //else //code==1 //client  nouveau candidat
  if (continuer()) election(); //passe la main  un nouveau processus
  else
  {
   affiche("Plus de temps");
   stop();
  }
 }
}

void GrandElecteur::affiche(string texte)
{
 cout<<"Serveur : "<<texte<<endl;
}

