//GrandElecteur.h

#include "Utilitaires.h"
#include <time.h>
#include <fcntl.h> //pour pid_t

class GrandElecteur
{
 private:
  int *table;  //tableau contenant les n de processus des clients (actif ou candidats)
  int size; //nombre de cellules occues de table
  int capacity; //nombre total de cellules de table
  struct Tmsgperso{long etiquette; char contenu;} msgperso; //structure pour la file de messages
  int idfile; //descripteur de la file
  int tube; //descripteur de tube nomm
  int numProcActif; //numro du processus actif
  time_t heureDepart; //heure de cration de l'instance de GrandElecteur
  short tempsMax; //dure maxi d'excution en secondes
  bool ok; //GrandElecteur s'arrte si ok est  false
  short politique; //politique d'lection choisie
  short dernierElu; //Indice du dernier Client lu avec la politique LILO
 protected:
  void create(short politik,short temps); //sutite du constructeur
  int selection(); //retourne un n de processus au hasard
  char randQuantum(); //retourne un quantum de temps (secondes) au hasard entre 1 et 3
  int getClient(int numProc); //retourne l'index dans table du client de n de processus numProc
  void addClient(int numProc); //ajoute un n de processus  table
  void rmClient(int numProc); //supprime un n de processus de table
  void election(); //appelle selection() puis transmet au processus concern son lection
  void transmettre(int numProc, char quantumTemps); //transmet au client n numProc le message codeMessage
  bool continuer(); //retourne si le GrandElecteur doit continuer son travail (arrt au bout de tempsMax)
  void ecouterTube(); //reoit les signaux du client actif et agit en consquence
  void affiche(string texte); //affiche le texte sur la sortie standard
 public:
  GrandElecteur();
  GrandElecteur(short politik);
  GrandElecteur(short politik, short temps);
  ~GrandElecteur();
  void run(pid_t premierClient); //pour dmarrer l'activit de GrandElecteur
  void stop(); //pour arrter l'activit de GrandElecteur
};
