//MainOrdonnanceur.cc

#include "GrandElecteur.h"
#include "Client.h"
#include "Utilitaires.h"
#include <iostream.h> //entres sorties
#include <unistd.h> //pour le fork
#include <fcntl.h> //pour pid_t
#include <string.h>
#include <stdlib.h>

void affiche(char *texte) //affiche le texte sur la sortie standard
{
 cout<<"MainOrdonnanceur : "<<texte<<endl;
}

bool lireChoixAutomatique() //permet  l'utilisateur d'entrer le choix que doit faire le Client
{
 affiche("AUTOMATIQUE=1 - MANUEL=2");
 short lecture;
 cin>>lecture;
 if (lecture==1) return true;
 else if (lecture==2) return false;
 else return lireChoixAutomatique();
}

short lireChoixPolitique(short maxi) //permet  l'utilisateur d'entrer le choix de la politique d'lection
{
 affiche("RANDOM=1 - TOURNIQUET=2 - LILO=3 - FIFO=4");
 short lecture;
 cin>>lecture;
 if ((1<=lecture)&&(lecture<=maxi)) return lecture;
 else lireChoixPolitique(maxi);
}

short lireChoixTemps(short maxi) //permet  l'utilisateur d'entrer le choix que doit faire le Client
{
 affiche("Temps d'excution en secondes");
 short lecture;
 cin>>lecture;
 if ((1<=lecture)&&(lecture<=maxi)) return lecture;
 else lireChoixTemps(maxi);
}

void main()
{
 system("clear"); //efface la console
 bool automatique=lireChoixAutomatique();
 if (automatique) affiche("Mode automatique");
 else affiche("Mode manuel");
 system("clear");
 short politique=lireChoixPolitique(4);
 cout<<"MainOrdonnanceur politique : "<<politique<<endl;
 system("clear");
 short temps=lireChoixTemps(120);
 system("clear");
 pid_t monpid=fork(); //duplique le processus en cours
 switch (monpid)
 {
  case -1 : //erreur de fork()
  {
   exit(1);
   break;
  }
  case 0 : //processus fils : premier Client
  {
   sleep(1);
   Client *monClient=new Client(automatique); //le run puis le delete sont appels dans le constructeur
   //!! le code ci-dessous est appel par tous les clients
   break;
  }
  default : //processus pre : GrandElecteur
  {
   GrandElecteur *monGrandElecteur=new GrandElecteur(politique,temps);
   monGrandElecteur->run(monpid); //passe le pid du premier client
   delete monGrandElecteur;
   affiche("Fin du processus de GrandElecteur");
  }
 }
}
